
ThreatFactor NSIA - Bug #282

Error On Scan Results with Less Than 0 Deviations

11/29/2010 02:23 PM - Luke Murphey

Status: Closed Start date: 12/03/2010

Priority: Normal Due date: 12/05/2010

Assignee: Luke Murphey % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 1.0.2   

Description

Error message is:

stack_trace = "javax.servlet.ServletException: Exception thrown while generating view

net.lukemurphey.nsia.web.WebConsoleServlet.doRequest(WebConsoleServlet.java:89) at

net.lukemurphey.nsia.web.WebConsoleServlet.doGet(WebConsoleServlet.java:120) at

javax.servlet.http.HttpServlet.service(HttpServlet.java:115) at javax.servlet.http.HttpServlet.service(HttpServlet.java:92) at

org.mortbay.jetty.servlet.ServletHolder.handle(ServletHolder.java:428) at

org.mortbay.jetty.servlet.WebApplicationHandler.dispatch(WebApplicationHandler.java:473) at

org.mortbay.jetty.servlet.ServletHandler.handle(ServletHandler.java:568) at

org.mortbay.http.HttpContext.handle(HttpContext.java:1530) at

org.mortbay.jetty.servlet.WebApplicationContext.handle(WebApplicationContext.java:633) at

org.mortbay.http.HttpContext.handle(HttpContext.java:1482) at org.mortbay.http.HttpServer.service(HttpServer.java:909) at

org.mortbay.http.HttpConnection.service(HttpConnection.java:820) at

org.mortbay.http.HttpConnection.handleNext(HttpConnection.java:986) at

org.mortbay.http.HttpConnection.handle(HttpConnection.java:837) at

org.mortbay.http.SocketListener.handleConnection(SocketListener.java:245) at

org.mortbay.util.ThreadedServer.handle(ThreadedServer.java:357) at

org.mortbay.util.ThreadPool$PoolThread.run(ThreadPool.java:534)

Caused by:net.lukemurphey.nsia.web.ViewFailedException: Exception thrown while rendering template

net.lukemurphey.nsia.web.templates.TemplateLoader.renderToResponse(TemplateLoader.java:59) at

net.lukemurphey.nsia.web.views.WebDiscoveryScanResultView.process(WebDiscoveryScanResultView.java:159) at

net.lukemurphey.nsia.web.views.ScanResultView.process(ScanResultView.java:126) at

net.lukemurphey.nsia.web.View.process(View.java:90) at net.lukemurphey.nsia.web.View.process(View.java:58) at

net.lukemurphey.nsia.web.WebConsoleServlet.doRequest(WebConsoleServlet.java:83) at

net.lukemurphey.nsia.web.WebConsoleServlet.doGet(WebConsoleServlet.java:120) at

javax.servlet.http.HttpServlet.service(HttpServlet.java:115) at javax.servlet.http.HttpServlet.service(HttpServlet.java:92) at

org.mortbay.jetty.servlet.ServletHolder.handle(ServletHolder.java:428) at

org.mortbay.jetty.servlet.WebApplicationHandler.dispatch(WebApplicationHandler.java:473) at

org.mortbay.jetty.servlet.ServletHandler.handle(ServletHandler.java:568) at

org.mortbay.http.HttpContext.handle(HttpContext.java:1530) at

org.mortbay.jetty.servlet.WebApplicationContext.handle(WebApplicationContext.java:633) at

org.mortbay.http.HttpContext.handle(HttpContext.java:1482) at org.mortbay.http.HttpServer.service(HttpServer.java:909) at

org.mortbay.http.HttpConnection.service(HttpConnection.java:820) at

org.mortbay.http.HttpConnection.handleNext(HttpConnection.java:986) at

org.mortbay.http.HttpConnection.handle(HttpConnection.java:837) at

org.mortbay.http.SocketListener.handleConnection(SocketListener.java:245) at

org.mortbay.util.ThreadedServer.handle(ThreadedServer.java:357) at

org.mortbay.util.ThreadPool$PoolThread.run(ThreadPool.java:534)

Caused by:freemarker.template.TemplateException: Error executing macro: summaryrow

required parameter: value is not specified.

freemarker.core.Macro$Context.sanityCheck(Macro.java:207) at freemarker.core.Macro$Context.runMacro(Macro.java:165) at

freemarker.core.Environment.visit(Environment.java:602) at freemarker.core.UnifiedCall.accept(UnifiedCall.java:106) at

freemarker.core.Environment.visit(Environment.java:209) at freemarker.core.MixedContent.accept(MixedContent.java:92) at

freemarker.core.Environment.visit(Environment.java:209) at freemarker.core.Environment.visit(Environment.java:298) at

freemarker.core.BlockAssignment.accept(BlockAssignment.java:83) at freemarker.core.Environment.visit(Environment.java:209) at

freemarker.core.MixedContent.accept(MixedContent.java:92) at freemarker.core.Environment.visit(Environment.java:209) at

freemarker.core.Environment.process(Environment.java:189) at freemarker.template.Template.process(Template.java:237) at

net.lukemurphey.nsia.web.templates.TemplateLoader.renderToResponse(TemplateLoader.java:55) at

net.lukemurphey.nsia.web.views.WebDiscoveryScanResultView.process(WebDiscoveryScanResultView.java:159) at

net.lukemurphey.nsia.web.views.ScanResultView.process(ScanResultView.java:126) at
net.lukemurphey.nsia.web.View.process(View.java:90) at net.lukemurphey.nsia.web.View.process(View.java:58) at

net.lukemurphey.nsia.web.WebConsoleServlet.doRequest(WebConsoleServlet.java:83) at

net.lukemurphey.nsia.web.WebConsoleServlet.doGet(WebConsoleServlet.java:120) at

javax.servlet.http.HttpServlet.service(HttpServlet.java:115) at javax.servlet.http.HttpServlet.service(HttpServlet.java:92) at

org.mortbay.jetty.servlet.ServletHolder.handle(ServletHolder.java:428) at

org.mortbay.jetty.servlet.WebApplicationHandler.dispatch(WebApplicationHandler.java:473) at

org.mortbay.jetty.servlet.ServletHandler.handle(ServletHandler.java:568) at

org.mortbay.http.HttpContext.handle(HttpContext.java:1530) at

org.mortbay.jetty.servlet.WebApplicationContext.handle(WebApplicationContext.java:633) at

org.mortbay.http.HttpContext.handle(HttpContext.java:1482) at org.mortbay.http.HttpServer.service(HttpServer.java:909) at

org.mortbay.http.HttpConnection.service(HttpConnection.java:820) at

org.mortbay.http.HttpConnection.handleNext(HttpConnection.java:986) at

org.mortbay.http.HttpConnection.handle(HttpConnection.java:837) at

org.mortbay.http.SocketListener.handleConnection(SocketListener.java:245) at

org.mortbay.util.ThreadedServer.handle(ThreadedServer.java:357) at

org.mortbay.util.ThreadPool$PoolThread.run(ThreadPool.java:534)"

Related issues:

Related to ThreatFactor NSIA - Bug #281: Scan Failure Shows up as Negative Nu... Closed 12/02/2010 12/04/2010

History

#1 - 11/29/2010 02:23 PM - Luke Murphey

Example on internal scanner at http://10.0.2.201:8080/ScanResult/272255/

#2 - 11/29/2010 07:27 PM - Luke Murphey

The template for the web discovery scan result fails because the specimen description is empty.

#3 - 11/29/2010 07:33 PM - Luke Murphey

The database shows a warning at Nov 24, 2010 12:04:48 AM (the scan result in question completes at Nov 24, 2010 12:03:48 AM):

java.sql.SQLTransactionRollbackException: A lock could not be obtained within the time requested

org.apache.derby.impl.jdbc.SQLExceptionFactory40.getSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.Util.generateCsSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.TransactionResourceImpl.wrapInSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.TransactionResourceImpl.handleException(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedConnection.handleException(Unknown Source) at

org.apache.derby.impl.jdbc.ConnectionChild.handleException(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedStatement.executeStatement(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedPreparedStatement.executeStatement(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedPreparedStatement.execute(Unknown Source) at

org.apache.commons.dbcp.DelegatingPreparedStatement.execute(DelegatingPreparedStatement.java:168) at

net.lukemurphey.nsia.scan.HttpSeekingScanResult.saveToDatabase(HttpSeekingScanResult.java:361) at

net.lukemurphey.nsia.Scanner.run(Scanner.java:127)

Caused by:java.sql.SQLException: A lock could not be obtained within the time requested

org.apache.derby.impl.jdbc.SQLExceptionFactory.getSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.SQLExceptionFactory40.wrapArgsForTransportAcrossDRDA(Unknown Source) at

org.apache.derby.impl.jdbc.SQLExceptionFactory40.getSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.Util.generateCsSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.TransactionResourceImpl.wrapInSQLException(Unknown Source) at

org.apache.derby.impl.jdbc.TransactionResourceImpl.handleException(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedConnection.handleException(Unknown Source) at

org.apache.derby.impl.jdbc.ConnectionChild.handleException(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedStatement.executeStatement(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedPreparedStatement.executeStatement(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedPreparedStatement.execute(Unknown Source) at

org.apache.commons.dbcp.DelegatingPreparedStatement.execute(DelegatingPreparedStatement.java:168) at

net.lukemurphey.nsia.scan.HttpSeekingScanResult.saveToDatabase(HttpSeekingScanResult.java:361) at

net.lukemurphey.nsia.Scanner.run(Scanner.java:127)

Caused by:ERROR 40XL1: A lock could not be obtained within the time requested

org.apache.derby.iapi.error.StandardException.newException(Unknown Source) at

org.apache.derby.impl.services.locks.ConcurrentLockSet.lockObject(Unknown Source) at

org.apache.derby.impl.services.locks.AbstractPool.lockObject(Unknown Source) at

org.apache.derby.impl.store.raw.xact.RowLocking3.lockRecordForRead(Unknown Source) at

org.apache.derby.impl.store.access.heap.HeapController.lockRow(Unknown Source) at

org.apache.derby.impl.store.access.heap.HeapController.lockRow(Unknown Source) at

org.apache.derby.impl.store.access.btree.index.B2IRowLocking3.lockRowOnPage(Unknown Source) at
org.apache.derby.impl.store.access.btree.index.B2IRowLocking3._lockScanRow(Unknown Source) at

org.apache.derby.impl.store.access.btree.index.B2IRowLockingRR.lockScanRow(Unknown Source) at

org.apache.derby.impl.store.access.btree.BTreeForwardScan.fetchRows(Unknown Source) at

org.apache.derby.impl.store.access.btree.BTreeScan.fetchNext(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getDescriptorViaIndexMinion(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getDescriptorViaIndex(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getColumnDescriptorsScan(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getColumnDescriptorsScan(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.finishTableDescriptor(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getTableDescriptorIndex2Scan(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getUncachedTableDescriptor(Unknown Source) at

org.apache.derby.impl.sql.catalog.OIDTDCacheable.setIdentity(Unknown Source) at

org.apache.derby.impl.services.cache.ConcurrentCache.find(Unknown Source) at

org.apache.derby.impl.sql.catalog.DataDictionaryImpl.getTableDescriptor(Unknown Source) at

org.apache.derby.impl.sql.execute.InsertResultSet.normalInsertCore(Unknown Source) at

org.apache.derby.impl.sql.execute.InsertResultSet.open(Unknown Source) at

org.apache.derby.impl.sql.GenericPreparedStatement.executeStmt(Unknown Source) at

org.apache.derby.impl.sql.GenericPreparedStatement.execute(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedStatement.executeStatement(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedPreparedStatement.executeStatement(Unknown Source) at

org.apache.derby.impl.jdbc.EmbedPreparedStatement.execute(Unknown Source) at

org.apache.commons.dbcp.DelegatingPreparedStatement.execute(DelegatingPreparedStatement.java:168) at

net.lukemurphey.nsia.scan.HttpSeekingScanResult.saveToDatabase(HttpSeekingScanResult.java:361) at

net.lukemurphey.nsia.Scanner.run(Scanner.java:127)

See http://127.0.0.1:8080/System/Eventlog/310379/?Severity=3x%x%

#4 - 11/29/2010 07:37 PM - Luke Murphey

There is another similar exception at Nov 22, 2010 12:03:46 AM. This is the second such error around midnight. This is likely due to the nightly index

refresh which occurs at midnight.

#5 - 11/29/2010 07:50 PM - Luke Murphey

Need to disable the database re-indexer and add the option to manually perform database reindexing.

#6 - 11/29/2010 08:30 PM - Luke Murphey

- Status changed from New to Resolved

- % Done changed from 0 to 100

Automatic database defragmentation is now disabled. Will monitor installation that contained the problem to determine if this fixes it.

#7 - 12/03/2010 10:26 PM - Luke Murphey

- Status changed from Resolved to Closed
